{ kontroll.pas                                                              }
{ 2001-03-31 programmeerimisolmpiaadi 4. lesande testija                  }
{    KOBE                                                                   }
{ Indrek Jentson                                                            }

PROGRAM KOOPAD_CHECK;

CONST
  MAXN = 100;  { maksimaalne koobaste arv }
  MAXM = 1000; { maksimaalne kikude arv }
  COLORED = 100; { konstant "vrvitud" serva thistamiseks }
  EMPTY = -1;    { konstant mitteeksisteeriva serva thistamiseks }

TYPE
  MAXNJADA = ARRAY[0..MAXN+1] OF INTEGER;
  MAXMJADA = ARRAY[1..MAXM*3] OF INTEGER;

VAR
  G : ARRAY[0..MAXN, 0..MAXN] OF INTEGER; { Graaf }
  N : INTEGER;                            { Tegelik tippude arv graafis }
  M : INTEGER;                            { Tegelik servade arv graafis }
  T : MAXMJADA;                           { Massiiv vastuse hoidmiseks }
  K : INTEGER;				  { Kasutatavate kikude arv }
  KS : INTEGER;                           { Minimaalne vajalik lnga pikkus }
  ZLEN, ZPOINTS : INTEGER;

FUNCTION ANDMETE_SISESTAMINE : BOOLEAN;
VAR
  SF : TEXT;
  I, A, B, L : INTEGER;
BEGIN
  { Algvrtustame massiivi G }
  FOR I := 0 TO MAXN DO
    FOR A := 0 TO MAXN DO
      G[I,A] := EMPTY;        { EMPTY thistab puuduvat serva }

  ASSIGN(SF, paramstr(1));
{$I-}
  RESET(SF);
{$I+}
  IF IORESULT = 0 THEN
    BEGIN
      READ(SF, N, M);
      FOR I := 1 TO M DO
        BEGIN
	  READ(SF, A, B, L);
	  G[A, B] := L;  { Tippude A ja B vahel on serv pikkusega L }
	  G[B, A] := L;
	END;
      CLOSE(SF);
      ASSIGN(SF, paramstr(2));
      RESET(SF);
      READ(SF, ZLEN, ZPOINTS);
      CLOSE(SF);
      ANDMETE_SISESTAMINE := TRUE;
    END
  ELSE
    ANDMETE_SISESTAMINE := FALSE;
END;

PROCEDURE KONTROLLIMINE;
VAR
  I, J, X, P, MAXGS, GS : INTEGER;
  CF :TEXT;
  R : REAL;
  ERR : BOOLEAN;

  FUNCTION GET_NEXT_POINT : INTEGER;
  VAR RES : INTEGER;
  BEGIN
    IF NOT EOF(CF) THEN
      BEGIN
        INC(X);
        READ(CF, RES);
        IF (RES > 0) AND (RES <= N) THEN
          GET_NEXT_POINT := RES
        ELSE IF NOT EOF(CF) THEN
          BEGIN
            ERR := TRUE;
            WRITELN('Viga ',x,'-nda arvu lugemisel! Number ',
              res,' ei thista koobast!' );
            GET_NEXT_POINT := 1;
          END;
      END
    ELSE
      GET_NEXT_POINT := 1;
  END;

BEGIN
  WRITELN; WRITELN('Kontrollime ...'); WRITELN;
  ASSIGN(CF, paramstr(3));
  RESET(CF);
  READLN(CF, MAXGS);
  ERR := FALSE;
  GS := 0;
  X := 1;
  I := GET_NEXT_POINT;
  REPEAT
    J := GET_NEXT_POINT;
    IF NOT ERR AND NOT EOF(CF) THEN
      BEGIN
        IF G[I,J] > EMPTY THEN
          BEGIN
            GS := GS + G[I,J];
            G[I,J] := G[I,J] - COLORED;
            G[J,I] := G[J,I] - COLORED;
          END
        ELSE
          BEGIN
            IF G[I,J] = EMPTY THEN
              WRITELN('Viga: ptakse kasutada serva (',i,',',j,'), mida pole olemas!' )
            ELSE IF G[I,J] < EMPTY THEN
              WRITELN('Viga: ptakse kasutada serva (',i,',',j,'), mida on juba ks kord kasutatud!' );
            ERR := TRUE;
          END;
        I := J;
      END;
  UNTIL ERR OR EOF(CF);
  CLOSE(CF);
  IF GS <> MAXGS THEN
    BEGIN
      WRITELN('Hoiatus: vastuseks pakutud teepikkus ',maxgs,
        'm erineb arvutatud teepikkusest ',gs,'m!');
    END;
  IF NOT ERR THEN
    BEGIN
      WRITELN('Zrii tulemus on ',zlen,
        'm, antud lahenduse tulemus on ',gs,'m.');
      R := ZPOINTS * SQR(GS*1.0/ZLEN*1.0);
      IF TRUNC(R) < R THEN P := TRUNC(R)+1
      ELSE P := TRUNC(R);
      IF P > ZPOINTS * 1.5 THEN
        P := TRUNC(ZPOINTS * 1.5);
      WRITELN('Testi vrtus on ',zpoints,' punkti, lahendus saab ',p,' punkti.');
    END;
END;

BEGIN
  IF ANDMETE_SISESTAMINE THEN
    BEGIN
    KONTROLLIMINE;
    END
  ELSE WRITELN('Sisendandmete faili ei nnestunud lugeda.');
END.

